<?php
/**
 * Template Name: Full Width Page
 *
 * The full width template does not display any sidebar.
 *
 * @package Forty_Two
 * @license GPL-2.0-or-later
 * @link    https://aspengrovestudios.com/themes/forty-two/
 */

// This file should match the `singular.php` template exactly.
get_header();

?>

			<main id="main" class="site-main">

				<?php
				while ( have_posts() ) {
					the_post();

					if ( forty_two_use_post_format_templates() ) {
						get_template_part( 'template-parts/content/content-' . get_post_type(), get_post_format() );
					} else {
						get_template_part( 'template-parts/content/content', get_post_type() );
					}

					if ( forty_two_display_post_navigation() ) {
						the_post_navigation();
					}

					if ( forty_two_display_post_comments() ) {
						comments_template();
					}
				}
				?>

			</main><!-- #main -->

<?php

get_sidebar();
get_footer();
