<?php
/**
 * The template for displaying the footer navigation
 *
 * @package Forty_Two
 * @license GPL-2.0-or-later
 * @link    https://aspengrovestudios.com/themes/forty-two/
 */

if ( ! forty_two_is_menu_active( 'footer' ) ) {
	return;
}

?>
<nav class="footer-navigation site-component" aria-label="<?php esc_attr_e( 'Footer Menu', 'forty-two' ); ?>" role="navigation">
	<div class="site-component-inner">
		<?php forty_two_render_menu( 'footer' ); ?>
	</div>
</nav><!-- .footer-navigation -->
